
#include <sourcemod>
#include <cstrike>
#include <sdktools>

#pragma semicolon 1
#define PLUGIN_VERSION "1.3.3.9"
#define MAX_PLAYERS 256

new Handle:Spawn_Timer[MAXPLAYERS+1];
new Handle:Check_Timer[MAXPLAYERS+1];

new g_SpawnBlocked;

public Plugin:myinfo = 
{
	name = "Auto Respawn",
	author = "das d!",
	description = "Player respawn",
	version = PLUGIN_VERSION,
};

// When plugin starts
public OnPluginStart()
{
	HookEvent("player_team", Event_ChangeTeam, EventHookMode_Post);
	RegConsoleCmd("say", Command_Say);
	RegConsoleCmd("say_team", Command_Say);
	RegConsoleCmd("joinclass", Command_JoinClass);
	PrintToServer( ".------------------------------------------------------." );
	PrintToServer( "|                 AutoSpawn   Loaded                   |" );
	PrintToServer( "'------------------------------------------------------'" );
}

public Action:Event_ChangeTeam(Handle:event,const String:name[],bool:dontBroadcast){
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(client != 0){
		Check_Timer[client] = CreateTimer( 1.0, TeamAlive_Check, client, TIMER_FLAG_NO_MAPCHANGE);
	}
}

public Action:TeamAlive_Check(Handle:timer, any:client){
	if(IsClientInGame(client) && !IsPlayerAlive(client) && (GetClientTeam(client) == 2 || GetClientTeam(client) == 3)){
		//PrintToChat(client, "\x04You will respawn in 5 sec!!!");
		Check_Timer[client] = INVALID_HANDLE;
		g_SpawnBlocked = 0;
		Spawn_Timer[client] = CreateTimer( 1.0, Do_Spawn, client, TIMER_FLAG_NO_MAPCHANGE);
	}
	else{
		Check_Timer[client] = INVALID_HANDLE;
		g_SpawnBlocked = 0;
	}
}

public Action:Do_Spawn(Handle:timer, any:client){
	if(client != 0 && IsClientInGame(client) && !IsPlayerAlive(client) && (GetClientTeam(client) == 2 || GetClientTeam(client) == 3)){
		g_SpawnBlocked = 1;
		CS_RespawnPlayer(client);
		Spawn_Timer[client] = INVALID_HANDLE;
	}
	else{
		PrintToChat(client, "\x04Unable to spawn.");
		Spawn_Timer[client] = INVALID_HANDLE;
	}
}

public Action:Command_JoinClass(client, args)
{
	if(g_SpawnBlocked == 1)
	{
		FakeClientCommandEx(client, "spec_mode");
		return Plugin_Handled; // block it
	}
	else
	{
		return Plugin_Continue; // allow it
	}
}

public OnClientDisconnect(client)
{
	if(Spawn_Timer[client] != INVALID_HANDLE){
		CloseHandle(Spawn_Timer[client]);
		Spawn_Timer[client] = INVALID_HANDLE;
	}
	if(Check_Timer[client] != INVALID_HANDLE){
		CloseHandle(Check_Timer[client]);
		Check_Timer[client] = INVALID_HANDLE;
	}
}

public Action:Command_Say(client, args) {
	if(client == 0 && !IsDedicatedServer())
		client = 1;
	
	if(client < 1)
		return Plugin_Continue;
		
	decl String:command[32], String:value[32];
	
	GetCmdArg(0, command, sizeof(command));
	GetCmdArg(1, value, sizeof(value));
	
	if(StrEqual(value, "spawn") || StrEqual(value, "respawn") || StrEqual(value, "redie") || StrEqual(value, "!spawn") || StrEqual(value, "!respawn") || StrEqual(value, "!redie")) {
		new team = GetClientTeam(client);
		
		if(team != CS_TEAM_CT && team != CS_TEAM_T) {
			PrintToChat(client, "\x04This command is not available to spectators.");
			return Plugin_Handled;
		}
		
		if(IsPlayerAlive(client)) {
			PrintToChat(client, "\x04You are alive, dont bug me!!!");
			return Plugin_Handled;
		}
		
		CS_RespawnPlayer(client);
		
		return Plugin_Handled;
	}
	
	return Plugin_Continue;
}

public OnPluginEnd()
{
// When plugin is unloaded, unhook the jump event, and spawn event.
	UnhookEvent("player_team", Event_ChangeTeam);
}
