public Plugin:myinfo = {
	name = "SurfTimer TempInfos",
	author = "das d!",
	description = "private",
	version = "1.0",
	url = "www.devil-hunter-multigaming.de"
}

#define MAX_MAP_LENGTH 32
#define RECORD_TIME 0
#define RECORD_JUMP 1
#define YELLOW 0x01
#define TEAMCOLOR 0x02
#define LIGHTGREEN 0x03
#define GREEN 0x04
#define OLIVE 0x05

new Handle:g_hDb = INVALID_HANDLE;



public OnPluginStart(){
	RegConsoleCmd("sm_mtop", Client_MapTop10_Record, "Displays Top10 of a given map");
	RegConsoleCmd("sm_mbtop", Client_MapBounsTop10_Record, "Displays BTop10 of a given map");
	db_setupDatabase();
}

public db_setupDatabase(){
	decl String:szError[255];
	g_hDb = SQL_Connect("timer", false, szError, 255);
	
	//if a connection canot be made
	if(g_hDb == INVALID_HANDLE){
		LogError("[cP Mod] Unable to connect to database (%s)", szError);
		return;
	}
}



//#################### !mtop ##################################

new String:sql_selectTimeWorldRecord[] = "SELECT name, time, jumps, map FROM round WHERE map = '%s' AND bonus = '0' ORDER BY time ASC LIMIT 100;";

public Action:Client_MapTop10_Record(client, args){
	//if not enough arguments
	if(args < 1){
		ReplyToCommand(client, "[SM] Usage: sm_mtop <mapname>");
		return Plugin_Handled;
	}
	else if(args == 1){
		decl String:szMapName[MAX_MAP_LENGTH];
		GetCmdArg(1, szMapName, MAX_NAME_LENGTH);
		
		MapTop10Panel(client, szMapName);
	}
	
	return Plugin_Handled;
}
public MapTop10Panel(client, String:szMapName[MAX_MAP_LENGTH]){
	db_selectMapTop10Record(client, szMapName);
}
public db_selectMapTop10Record(client, String:szMapName[MAX_MAP_LENGTH]){
	decl String:szQuery[255];
	
	Format(szQuery, 255, sql_selectTimeWorldRecord, szMapName);
	new Handle:pack = CreateDataPack();
	WritePackCell(pack, client);
	WritePackString(pack, szMapName);
	
	SQL_TQuery(g_hDb, SQL_SelectMapTop10Callback, szQuery, pack);
}

//----------//
// callback //
//----------//
public SQL_SelectMapTop10Callback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if(hndl == INVALID_HANDLE)
		LogError("Error loading maptop100 (%s)", error);
	
	//new client = data;
	
	new Handle:pack = data;
	ResetPack(pack);
	new client = ReadPackCell(pack);
	decl String:szMapName[MAX_MAP_LENGTH];
	ReadPackString(pack, szMapName, MAX_MAP_LENGTH);
	CloseHandle(pack);
	
	decl String:szValue[64];
	decl String:szName[MAX_NAME_LENGTH];
	//decl String:szMapName[MAX_MAP_LENGTH];
	decl String:szTop10Map[MAX_MAP_LENGTH];
	new jumps;
	decl String:szVrTime[16];
	
	new Handle:menu = CreateMenu(MenuHandler1);
	Format(szTop10Map, MAX_MAP_LENGTH, "Map: %s", szMapName);
	SetMenuTitle(menu, "Map Top100\nMap: %s\n ", szTop10Map);
	//SQL_FetchString(hndl, 3, szMapName, MAX_MAP_LENGTH);
	
	//if there is allready a entry
	if(SQL_HasResultSet(hndl)){
		new i = 1;
		//loop all results
		while (SQL_FetchRow(hndl)){
			//fetch and format
			SQL_FetchString(hndl, 0, szName, MAX_NAME_LENGTH);
			jumps = SQL_FetchInt(hndl, 2);
			Timer_SecondsToTime(SQL_FetchFloat(hndl, 1), szVrTime, 16, 2);
			Format(szValue, 64, "#%i | %s - %s", i, szName, szVrTime, jumps);
			AddMenuItem(menu, szValue, szValue, ITEMDRAW_DISABLED);
			i++;
		}
		//still no record :/
		if(i == 1)
			AddMenuItem(menu, "No record found...", "No record found...", ITEMDRAW_DISABLED);
	}
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, 30);
}

// ###############################################################

//#################### !mbtop ##################################

new String:sql_selectbTimeWorldRecord[] = "SELECT name, time, jumps, map FROM round WHERE map = '%s' AND bonus = '1' ORDER BY time ASC LIMIT 100;";

public Action:Client_MapBounsTop10_Record(client, args){
	//if not enough arguments
	if(args < 1){
		ReplyToCommand(client, "[SM] Usage: sm_mbtop <mapname>");
		return Plugin_Handled;
	}
	else if(args == 1){
		decl String:szMapName[MAX_MAP_LENGTH];
		GetCmdArg(1, szMapName, MAX_NAME_LENGTH);
		
		MapbTop10Panel(client, szMapName);
	}
	
	return Plugin_Handled;
}
public MapbTop10Panel(client, String:szMapName[MAX_MAP_LENGTH]){
	db_selectMapbTop10Record(client, szMapName);
}
public db_selectMapbTop10Record(client, String:szMapName[MAX_MAP_LENGTH]){
	decl String:szQuery[255];
	
	Format(szQuery, 255, sql_selectbTimeWorldRecord, szMapName);
	new Handle:pack = CreateDataPack();
	WritePackCell(pack, client);
	WritePackString(pack, szMapName);
	
	SQL_TQuery(g_hDb, SQL_SelectMapbTop10Callback, szQuery, pack);
}

//----------//
// callback //
//----------//
public SQL_SelectMapbTop10Callback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if(hndl == INVALID_HANDLE)
		LogError("Error loading mapbonustop100 (%s)", error);
	
	//new client = data;
	
	new Handle:pack = data;
	ResetPack(pack);
	new client = ReadPackCell(pack);
	decl String:szMapName[MAX_MAP_LENGTH];
	ReadPackString(pack, szMapName, MAX_MAP_LENGTH);
	CloseHandle(pack);
	
	decl String:szValue[64];
	decl String:szName[MAX_NAME_LENGTH];
	//decl String:szMapName[MAX_MAP_LENGTH];
	decl String:szTop10Map[MAX_MAP_LENGTH];
	new jumps;
	decl String:szVrTime[16];
	
	new Handle:menu = CreateMenu(MenuHandler1);
	Format(szTop10Map, MAX_MAP_LENGTH, "Map: %s", szMapName);
	SetMenuTitle(menu, "Map Bonus Top100\nMap: %s\n ", szTop10Map);
	//SQL_FetchString(hndl, 3, szMapName, MAX_MAP_LENGTH);
	
	//if there is allready a entry
	if(SQL_HasResultSet(hndl)){
		new i = 1;
		//loop all results
		while (SQL_FetchRow(hndl)){
			//fetch and format
			SQL_FetchString(hndl, 0, szName, MAX_NAME_LENGTH);
			jumps = SQL_FetchInt(hndl, 2);
			Timer_SecondsToTime(SQL_FetchFloat(hndl, 1), szVrTime, 16, 2);
			Format(szValue, 64, "#%i | %s - %s", i, szName, szVrTime, jumps);
			AddMenuItem(menu, szValue, szValue, ITEMDRAW_DISABLED);
			i++;
		}
		//still no record :/
		if(i == 1)
			AddMenuItem(menu, "No record found...", "No record found...", ITEMDRAW_DISABLED);
	}
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, 30);
}

// ###############################################################

public MenuHandler1(Handle:menu, MenuAction:action, param1, param2)
{
	/* If an option was selected, tell the client about the item. */
	if (action == MenuAction_Select)
	{

	}
	/* If the menu was cancelled, print a message to the server about it. */
	else if (action == MenuAction_Cancel)
	{

	}
	/* If the menu has ended, destroy it */
	else if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
}

stock Timer_SecondsToTime(Float:seconds, String:buffer[], maxlength, precision)
{
	new t = RoundToFloor(seconds);
	
	new hour, mins;
	
	if (t >= 3600)
	{
		hour = RoundToFloor(t / 3600.0);
		t = t % 3600;
    }
	
	if (t >= 60)
	{
		mins = RoundToFloor(t / 60.0);
		t = t % 60;
    }

	Format(buffer, maxlength, "");
	
	if (hour)
		Format(buffer, maxlength, "%s%02d:", buffer, hour);
	
	Format(buffer, maxlength, "%s%02d:", buffer, mins);
	
	if (precision == 1)
		Format(buffer, maxlength, "%s%04.1f", buffer, float(t) + seconds - RoundToFloor(seconds));
	else if (precision == 2)
		Format(buffer, maxlength, "%s%05.2f", buffer, float(t) + seconds - RoundToFloor(seconds));
	else if (precision == 3)
		Format(buffer, maxlength, "%s%06.3f", buffer, float(t) + seconds - RoundToFloor(seconds));
	else 
		Format(buffer, maxlength, "%s%02d", buffer, t);
}