/* Plugin Template generated by Pawn Studio */

#include <sourcemod>
#include <timer>

new g_GetRowCount[MAXPLAYERS+1];

new String:sql_selectPlayerInfo[] = "SELECT time, map, auth FROM round WHERE auth LIKE '%s' AND jumps NOT LIKE '-1' AND time NOT LIKE '-1' ORDER BY map ASC;";
new String:sql_selectPlayerInfoRecord[] = "SELECT auth, name, jumps, time, date FROM round WHERE auth LIKE '%s' AND map = '%s' AND jumps NOT LIKE '-1' AND time NOT LIKE '-1';";
new String:sql_QueryPlayerName[] = "SELECT name, auth FROM round WHERE name LIKE \"%%%s%%\" AND jumps NOT LIKE '-1' AND time NOT LIKE '-1' ORDER BY `round`.`name` ASC;";
new String:sql_selectPlayerRecordBySteam[] = "SELECT auth, name, jumps, time, date FROM round WHERE auth LIKE '%s' AND name = '%s' AND jumps NOT LIKE '-1' AND time NOT LIKE '-1';";
new String:sql_selectPlayer_P_RankBySteam[] = "SELECT auth, name, points FROM points WHERE auth LIKE '%s' AND points NOT LIKE '0';";

public Plugin:myinfo = 
{
	name = "New Plugin",
	author = "Unknown",
	description = "<- Description ->",
	version = "1.0",
	url = "<- URL ->"
}

public OnPluginStart()
{
	//RegConsoleCmd("sm_playerinfo", Client_PlayerInfo);
}

public Action:Client_PlayerInfo(client, args)
{
	if(args < 1)
	{
		Self_Playerinfo(client);
	}
	else if(args >= 1)
	{
		// get the clients complete args in one string
		decl String:NameBuffer[256], String:NameClean[256];
		GetCmdArgString(NameBuffer, sizeof(NameBuffer));
		new startidx = 0;
		new len = strlen(NameBuffer);
		
		if ((NameBuffer[0] == '"') && (NameBuffer[len-1] == '"'))
		{
			startidx = 1;
			NameBuffer[len-1] = '\0';
		}
		
		Format(NameClean, sizeof(NameClean), "%s", NameBuffer[startidx]);
		// ---------------------------------------------
		
		// convert args into call
		QueryPlayerName(client, NameClean);
		// ----------------------
	}
	
	return Plugin_Handled;
}

public Action:Self_Playerinfo(client)
{
	new Handle:menu = CreateMenu(PlayerNFO_SelfOverview);
	SetMenuTitle(menu, "Your Overview\n ");
	AddMenuItem(menu, "pr", "View Record/Rank (current Map)");
	AddMenuItem(menu, "ppr", "View Points/Rank");
	AddMenuItem(menu, "playerinfo", "View all Records/Ranks");
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public PlayerNFO_SelfOverview(Handle:menu, MenuAction:action,param1, param2)
{
	if ( action == MenuAction_Select )
	{
		new String:info[256];

		/* Get item info */
		GetMenuItem(menu, param2, info, sizeof(info));
		switch (param2)
		{
			case 0:
			{
				RecordPanel(param1, g_szMapName)
			}
			case 1:
			{
				db_view_Point_Rank(param1);
			}
			case 2:
			{
				ViewPlayerInfo(param1);
			}
		}
	}
	else if (action == MenuAction_Cancel)
	{
		PrintToServer("Client %d's menu was cancelled.  Reason: %d", param1, param2);
	}
	/* If the menu has ended, destroy it */
	else if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
}

public QueryPlayerName(client, String:QueryPlayerName[256])
{
	db_QueryPlayerName(client, QueryPlayerName);
}

public db_QueryPlayerName(client, String:QueryPlayerName[256])
{
	decl String:szQuery[255];
	
	//escape some quote characters that could mess up the szQuery
	decl String:szName[MAX_NAME_LENGTH*2+1];
	SQL_QuoteString(g_hDb, QueryPlayerName, szName, MAX_NAME_LENGTH*2+1);
	
	Format(szQuery, 255, sql_QueryPlayerName, szName);
	
//	new Handle:pack = CreateDataPack();
//	WritePackCell(pack, client);
	
	SQL_TQuery(g_hDb, SQL_QueryRowCountCallback, szQuery, client);
	SQL_TQuery(g_hDb, SQL_QueryPlayerNameCallback, szQuery, client);
}


public SQL_QueryRowCountCallback(Handle:owner, Handle:hndl, const String:error[], any:data){
	if(hndl == INVALID_HANDLE)
		LogError("[Timer] Error loading playername (%s)", error);
		
	new client = data;
	decl String:RowName[256];
	decl String:RowNameChkDup[256];
	
	// get row counts
	if(SQL_HasResultSet(hndl)){
		// Loop over
		g_GetRowCount[client] = 0;
		while (SQL_FetchRow(hndl))
		{
			SQL_FetchString(hndl, 0, RowName, 256);
			if(RowNameChkDup[0] != RowName[0])	// suppress duplicate entrys
			{
				Format(RowNameChkDup, 256, "%s",RowName);
				g_GetRowCount[client]++;
			}
			else
			{
				Format(RowNameChkDup, 256, "%s",RowName);
			}
		}
	}
}

public SQL_QueryPlayerNameCallback(Handle:owner, Handle:hndl, const String:error[], any:data){
	if(hndl == INVALID_HANDLE)
		LogError("[Timer] Error loading playername (%s)", error);
		
	new client = data;
	decl String:PlayerName[256];
	decl String:SteamID[256];
	decl String:PlayerSteam[256];
	decl String:PlayerNameChkDup[256];
	decl String:PlayerNaStData[256];
	
	// Begin Menu
	new Handle:menu = CreateMenu(Menu_PlayerNameInfo);
	SetMenuTitle(menu, "%s\n ", Search_Menu_Title);
	
	// get player names
	if(SQL_HasResultSet(hndl)){
		// Loop over
		new i = 1;
		while (SQL_FetchRow(hndl))
		{
			if (g_GetRowCount[client] <= 100)
			{
				SQL_FetchString(hndl, 0, PlayerName, 256);
				SQL_FetchString(hndl, 1, SteamID, 256);
				Format(PlayerSteam, 256, "%s - %s",PlayerName, SteamID);
				Format(PlayerNaStData, 256, "%s:...||e|x|||p|l|:|.%s",PlayerName, SteamID);
				if(PlayerNameChkDup[0] != PlayerName[0])	// suppress duplicate entrys
				{
					AddMenuItem(menu, PlayerNaStData, PlayerSteam);
					Format(PlayerNameChkDup, 256, "%s",PlayerName);
					i++;
				}
				else
				{
					Format(PlayerNameChkDup, 256, "%s",PlayerName);
				}
			}
		}
		if((i == 1) && (g_GetRowCount[client] <= 100))
		{
			AddMenuItem(menu, "nope", "No Player found...", ITEMDRAW_DISABLED);
		}
		if(g_GetRowCount[client] >= 101)
		{
			AddMenuItem(menu, "many", "Too many Players found.", ITEMDRAW_DISABLED);
			AddMenuItem(menu, "speci", "Please be more specific.", ITEMDRAW_DISABLED);
		}
	}
	else{
		AddMenuItem(menu, "nope", "No Player found...", ITEMDRAW_DISABLED);
	}
	// -------------------
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
	//////////////////////
}

public Menu_PlayerNameInfo(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select)
	{
		new first_item = GetMenuSelectionPosition();
		DisplayMenuAtItem(menu, param1, first_item, MENU_TIME_FOREVER);
		new String:info[256];
 
		/* Get item info */
		GetMenuItem(menu, param2, info, sizeof(info));
		
		PlayerInfo_Overview(param1, info);
 
		/* Change the map */
		//ServerCommand("changelevel %s", info);
	}
}

public PlayerInfo_Overview(client, String:PlayerNaStData[256])
{
	decl String:PlayerData[3][256];
	ExplodeString(PlayerNaStData, ":...||e|x|||p|l|:|.", PlayerData, 3, 256);
	new Handle:menu = CreateMenu(PlayerNFO_Overview);
	SetMenuTitle(menu, "%s's Overview\n(%s)\n ", PlayerData[0], PlayerData[1]);
	AddMenuItem(menu, PlayerNaStData, "View Record/Rank (current Map)");
	AddMenuItem(menu, PlayerNaStData, "View Points/Rank");
	AddMenuItem(menu, PlayerNaStData, "View all Records/Ranks");
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public PlayerNFO_Overview(Handle:menu, MenuAction:action,param1, param2)
{
	if ( action == MenuAction_Select )
	{
		new String:info[256];

		/* Get item info */
		GetMenuItem(menu, param2, info, sizeof(info));
		decl String:PlayerData[3][256];
		ExplodeString(info, ":...||e|x|||p|l|:|.", PlayerData, 3, 256);
		switch (param2)
		{
			case 0:
			{
				decl String:szQuery[255];
				Format(szQuery, 255, sql_selectPlayerRecordBySteam, PlayerData[1], g_szMapName);

				new Handle:pack = CreateDataPack();
				WritePackCell(pack, param1);
				WritePackString(pack, g_szMapName);

				SQL_TQuery(g_hDb, SQL_ViewPlayerRecordCallback, szQuery, pack);
				
			}
			case 1:
			{
				//PrintToChat(param1, "db_viewPlayerPointRank(param1, %s)", PlayerData[0]);
				//db_viewPlayerPointRank(param1, PlayerData[0]);
				
				// experimental
				decl String:szQuery[255];
				Format(szQuery, 255, sql_selectPlayer_P_RankBySteam, PlayerData[1]);

				new Handle:pack = CreateDataPack();
				WritePackCell(pack, param1);

				SQL_TQuery(g_hDb, SQL_ViewPlayerPointRankCallback, szQuery, pack);
				
			}
			case 2:
			{
				decl String:szQuery[255];
				Format(szQuery, 255, sql_selectPlayerInfo, PlayerData[1]);
				SQL_TQuery(g_hDb, SQL_ViewPlayerInfoCallback, szQuery, param1);
			}
		}
	}
	else if (action == MenuAction_Cancel)
	{
		PrintToServer("Client %d's menu was cancelled.  Reason: %d", param1, param2);
	}
	/* If the menu has ended, destroy it */
	else if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
}























public ViewPlayerInfo(client)
{
	db_viewPlayerInfo(client);
}

public db_viewPlayerInfo(client){
	decl String:szQuery[255];
	decl String:szSteamId[32];
	GetClientAuthString(client, szSteamId, 32);
	
	Format(szQuery, 255, sql_selectPlayerInfo, szSteamId);
	
	SQL_TQuery(g_hDb, SQL_ViewPlayerInfoCallback, szQuery, client);
}

public SQL_ViewPlayerInfoCallback(Handle:owner, Handle:hndl, const String:error[], any:data){
	if(hndl == INVALID_HANDLE)
		LogError("[Timer] Error loading playerinfo (%s)", error);
		
	new client = data;
	decl String:szValue[64];
	decl String:szMapName[MAX_MAP_LENGTH];
	new time;
	decl String:szVrTime[16];
	decl String:SteamID[256];
	decl String:PlayerStMapData[256];
	
	// open mapcylce.txt and count maps
	new Handle:file = OpenFile("mapcycle.txt", "rt");
	if (file == INVALID_HANDLE)
	{
		LogError("[Timer] could not open mapcycle");
	}
	new String:mapname[255];
	new mapcount = 0;
	while (!IsEndOfFile(file) && ReadFileLine(file, mapname, sizeof(mapname)))
	{
		if (mapname[0] == ';' || !IsCharAlpha(mapname[0]))
		{
			continue;
		}
		/* Cut off the name at any whitespace */
		new len = strlen(mapname);
		for (new i=0; i<len; i++)
		{
			if (IsCharSpace(mapname[i]))
			{
				mapname[i] = '\0';
				break;
			}
		}
		/* Check if the map is valid */
		if (!IsMapValid(mapname))
		{
			continue;
		}
		mapcount++;
	}
	CloseHandle(file);
	////////////////////
	
	// Begin Menu
	new Handle:menu = CreateMenu(Menu_PlayerInfo);
	new mapscomplete = 0;
	if(SQL_HasResultSet(hndl) && SQL_FetchRow(hndl)){
		mapscomplete = SQL_GetRowCount(hndl);
	}
	/// Calc Percent
	new Float: mapcom_fl = float(mapscomplete);
	new Float: mapcou_fl = float(mapcount);
	new Float: Com_Per_fl = (mapcom_fl/mapcou_fl)*100;
	//////////////////////////
	
	SetMenuTitle(menu, "%i of %i (%.2f%%) maps completed\nRecords:\n ", mapscomplete, mapcount, Com_Per_fl);
	if(SQL_HasResultSet(hndl)){
		time = SQL_FetchInt(hndl, 0);
		SQL_FetchString(hndl, 1, szMapName, MAX_MAP_LENGTH);
		SQL_FetchString(hndl, 2, SteamID, 256);
		new time2 = time/1000;
		Format(szVrTime, 16, "%im %i.%is", time/60000, time2%60, time%1000);
		Format(szValue, 64, "%s - %s",szMapName, szVrTime);
		Format(PlayerStMapData, 256, "%s:...||e|x|||p|l|:|.%s",szMapName, SteamID);
		AddMenuItem(menu, PlayerStMapData, szValue);
		new i = 1;
		// Loop over
		while (SQL_FetchRow(hndl))
		{
			time = SQL_FetchInt(hndl, 0);
			new time3 = time/1000;
			SQL_FetchString(hndl, 1, szMapName, MAX_MAP_LENGTH);
			SQL_FetchString(hndl, 2, SteamID, 256);
			Format(szVrTime, 16, "%im %i.%is", time/60000, time3%60, time%1000);
			Format(szValue, 64, "%s - %s",szMapName, szVrTime);
			Format(PlayerStMapData, 256, "%s:...||e|x|||p|l|:|.%s",szMapName, SteamID);
			AddMenuItem(menu, PlayerStMapData, szValue);
			i++;
		}
	}
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
	//////////////////////
}

public Menu_PlayerInfo(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select)
	{
		new first_item = GetMenuSelectionPosition();
		DisplayMenuAtItem(menu, param1, first_item, MENU_TIME_FOREVER);
		new String:info[256];
 
		/* Get item info */
		GetMenuItem(menu, param2, info, sizeof(info));
		
		PlayerInfo_ShowRank(param1, info);
 
		/* Change the map */
		//ServerCommand("changelevel %s", info);
	}
}

public PlayerInfo_ShowRank(param1, String:PlayerStMapData[256])
{
	decl String:PlayerData[3][256];
	ExplodeString(PlayerStMapData, ":...||e|x|||p|l|:|.", PlayerData, 3, 256);
	new client = param1;
	PlayerInfoPanel(client, PlayerData[0], PlayerData[1]);
}

public PlayerInfoPanel(client, String:szMapName[256], String:szSteamId[256]){
	decl String:szQuery[255];
	
	//escape some quote characters that could mess up the szQuery
	
	Format(szQuery, 255, sql_selectPlayerInfoRecord, szSteamId, szMapName);
	
	new Handle:pack = CreateDataPack();
	WritePackCell(pack, client);
	WritePackString(pack, szMapName);
	
	SQL_TQuery(g_hDb, SQL_ViewPlayerInfoCallback2, szQuery, pack);
}
//----------//
// callback //
//----------//
public SQL_ViewPlayerInfoCallback2(Handle:owner, Handle:hndl, const String:error[], any:data){
	if(hndl == INVALID_HANDLE)
		LogError("[cP Mod] Error loading player record (%s)", error);
	
	new Handle:pack = data;
	ResetPack(pack);
	
	new client = ReadPackCell(pack);
	decl String:szMapName[MAX_MAP_LENGTH];
	ReadPackString(pack, szMapName, MAX_MAP_LENGTH);
	
	CloseHandle(pack);
	
	//if there is a player record
	if(SQL_HasResultSet(hndl) && SQL_FetchRow(hndl)){
	
		decl String:szSteamId[32];
		decl String:szName[MAX_NAME_LENGTH];
		new jumps;
		new time;
		decl String:szDate[20];
		
		//get the result
		SQL_FetchString(hndl, 0, szSteamId, 32);
		SQL_FetchString(hndl, 1, szName, MAX_NAME_LENGTH);
		jumps = SQL_FetchInt(hndl, 2);
		time = SQL_FetchInt(hndl, 3);
		SQL_FetchString(hndl, 4, szDate, 20);
		
		//call a method to display the rank text
		if(g_bRecordType == RECORD_TIME)
			db_viewPlayerInfoRank(client, szSteamId, szName, time, szMapName);
		else
			db_viewPlayerInfoRank(client, szSteamId, szName,jumps, szMapName);
	}
}

//////////////////////////////////////////

public db_viewPlayerInfoRank(client, String:szSteamId[32], String:szName[MAX_NAME_LENGTH], record, String:szMapName[MAX_MAP_LENGTH]){
	decl String:szQuery[510];
	
	if(g_bRecordType == RECORD_TIME)
		Format(szQuery, 510, sql_selectPlayerRankTime, szSteamId, szMapName, szMapName);
	else
		Format(szQuery, 510, sql_selectPlayerRankJump, szSteamId, szMapName, szMapName);
	
	new Handle:pack = CreateDataPack();
	WritePackCell(pack, client);
	WritePackString(pack, szMapName);
	WritePackString(pack, szSteamId);
	WritePackString(pack, szName);
	
	SQL_TQuery(g_hDb, SQL_ViewPlayerInfoCallback3, szQuery, pack);
}
//----------//
// callback //
//----------//
public SQL_ViewPlayerInfoCallback3(Handle:owner, Handle:hndl, const String:error[], any:data){
	if(hndl == INVALID_HANDLE)
		LogError("[cP Mod] Error viewing record (%s)", error);
	
	//if there is a player record
	if(SQL_HasResultSet(hndl) && SQL_FetchRow(hndl)){
		new rank = SQL_GetRowCount(hndl);
		
		//append data
		new Handle:pack = data;
		WritePackCell(pack, rank);
		
		db_viewPlayerInfo2(pack);
	}
}

//--------------------------//
// view player rank2 method //
//--------------------------//
public db_viewPlayerInfo2(any:data){
	decl String:szQuery[255];
	
	new Handle:pack = data;
	ResetPack(pack);
	ReadPackCell(pack);
	decl String:szMapName[MAX_MAP_LENGTH];
	ReadPackString(pack, szMapName, MAX_NAME_LENGTH);
	
	Format(szQuery, 255, sql_selectPlayerCount, szMapName);
	
	SQL_TQuery(g_hDb, SQL_ViewPlayerInfoCallback4, szQuery, data);
}
//----------//
// callback //
//----------//
public SQL_ViewPlayerInfoCallback4(Handle:owner, Handle:hndl, const String:error[], any:data){
	if(hndl == INVALID_HANDLE)
		LogError("[cP Mod] Error viewing record2 (%s)", error);
	
	new count = SQL_GetRowCount(hndl);
	
	new Handle:pack = data;
	ResetPack(pack);
	new client = ReadPackCell(pack);
	decl String:szMapName[MAX_MAP_LENGTH];
	ReadPackString(pack, szMapName, MAX_MAP_LENGTH);
	decl String:szSteamId[32];
	ReadPackString(pack, szSteamId, 32);
	decl String:szName[MAX_NAME_LENGTH];
	ReadPackString(pack, szName, MAX_NAME_LENGTH);
	new rank = ReadPackCell(pack);
	
	CloseHandle(pack);
	
	decl String:name[MAX_NAME_LENGTH+1];
	GetClientName(client, name, sizeof(name));
	
	if(name[0] != szName[0])
	{
		PrintToChat(client, "\x04[\x05Surf\x03Timer\x04] \x05%s \x01is ranked \x03%i/%i \x01on \x04%s", szName,rank,count,szMapName);
	}
	else
	{
		PrintToChat(client, "\x04[\x05Surf\x03Timer\x04] \x01You are ranked \x03%i/%i \x01on \x04%s", rank,count,szMapName);
	}
}