#pragma semicolon 1

#include <sourcemod>
#include <adminmenu>
#include <cstrike>
#include <sdktools>
#include <sdkhooks>
#include <smlib>

#include <timer>
#include <timer-logging>
#include <timer-worldrecord>
#include <timer-physics>

new bool:g_bRace = false;
new g_iRaceCountdown = 0;
new g_iRaceMode = 0;

public Plugin:myinfo =
{
    name        = "[Timer] Race System",
    author      = "Zipcore",
    description = "Race component for [Timer]",
    version     = PL_VERSION,
    url         = "zipcore#googlemail.com"
};

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	RegPluginLibrary("timer-race");

	return APLRes_Success;
}

public OnPluginStart()
{
	RegAdminCmd("sm_race", Command_Race, ADMFLAG_BAN, "Start a race.");
}

public OnMapStart()
{
	g_iRaceCountdown = 0;
	g_bRace = false;
}

public Action:Command_Race(client, args) 
{
	RaceMenu(client);
	return Plugin_Handled;
}

RaceMenu(client)
{
	new Handle:menu = CreateMenu(Handle_Menu_Menu);
			
	SetMenuTitle(menu, "Timer Menu");
	
	AddMenuItem(menu, "normal", ModeNames[MODE_NORMAL]);
	AddMenuItem(menu, "sideways", ModeNames[MODE_SIDEWAYS]);
	AddMenuItem(menu, "easy", ModeNames[MODE_EASY]);
	AddMenuItem(menu, "auto", ModeNames[MODE_AUTO]);
	AddMenuItem(menu, "3rd", ModeNames[MODE_THIRDPERSON]);
	AddMenuItem(menu, "fpsmax", ModeNames[MODE_FPSMAX]);
	AddMenuItem(menu, "lowgrav", ModeNames[MODE_LOWGRAV]);
	AddMenuItem(menu, "skittles", ModeNames[MODE_SKITTLES]);
	AddMenuItem(menu, "multihop", ModeNames[MODE_MULTIHOP]);
	AddMenuItem(menu, "nohop", ModeNames[MODE_NOHOP]);
	
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}
	
public Handle_Menu_Menu(Handle:menu, MenuAction:action, client, itemNum)
{
	new mode = -1;
	
	if(0 < client < GetMaxClients())
	{
		if ( action == MenuAction_Select )
		{
			decl String:info[100], String:info2[100];
			new bool:found = GetMenuItem(menu, itemNum, info, sizeof(info), _, info2, sizeof(info2));
			if(found)
			{
				if(StrEqual(info, "normal"))
				{
					mode = MODE_NORMAL;
				}
				else if(StrEqual(info, "sideways"))
				{
					mode = MODE_SIDEWAYS;
				}
				else if(StrEqual(info, "easy"))
				{
					mode = MODE_EASY;
				}
				else if(StrEqual(info, "auto"))
				{
					mode = MODE_AUTO;
				}
				if(StrEqual(info, "3rd"))
				{
					mode = MODE_THIRDPERSON;
				}
				else if(StrEqual(info, "fpsmax"))
				{
					mode = MODE_FPSMAX;
				}
				else if(StrEqual(info, "lowgrav"))
				{
					mode = MODE_LOWGRAV;
				}
				else if(StrEqual(info, "skittles"))
				{
					mode = MODE_SKITTLES;
				}
				if(StrEqual(info, "multihop"))
				{
					mode = MODE_MULTIHOP;
				}
				else if(StrEqual(info, "nohop"))
				{
					mode = MODE_NOHOP;
				}
			}
		}
	}
	
	if(mode != -1) 
	{
		g_iRaceMode = mode;
		g_iRaceCountdown = 10;
		CreateTimer(1.0, Timer_StartRaceCooldown, _, TIMER_FLAG_NO_MAPCHANGE|TIMER_REPEAT);
	}
}

public Action:Timer_StartRaceCooldown(Handle:timer)
{
	if(g_iRaceCountdown > 0) 
	{
		PrintCenterTextAll("Race starts in %d", g_iRaceCountdown);
		g_iRaceCountdown--;
		return Plugin_Continue;
	}
	else
	{
		PrintCenterTextAll("GO! GO! GO!!!");
		StartRace();
	
		return Plugin_Stop;
	}
}

StartRace()
{
	g_bRace = true;
	for (new i = 1; i <= GetMaxClients(); i++)
	{
		Timer_SetBonus(i, 0);
		Timer_SetMode(i, g_iRaceMode);
		
		if(!IsClientInGame(i))
		{
			continue;
		}
		if(!IsPlayerAlive(i))
		{
			continue;
		}
		
		FakeClientCommand(i, "sm_restart");
	}
}