public Plugin:myinfo = {
	name = "SurfTimer TempPlayerinfo",
	author = "das d!",
	description = "private",
	version = "1.0",
	url = "www.devil-hunter-multigaming.de"
}

enum eMain
{
    Handle:eMain_Pack,
    Handle:eMain_Menu
}

new Handle:g_hDb = INVALID_HANDLE;
new String:g_MapName[32];
new g_RowCount[MAXPLAYERS+1];
new g_PointRowCount[MAXPLAYERS+1];
new g_MainMenu[MAXPLAYERS+1][eMain]

public OnPluginStart(){
	RegConsoleCmd("sm_pi", Client_PlayerInfo, "playerinfo");
	db_setupDatabase();
}

public OnMapStart()
{
	GetCurrentMap(g_MapName, 32);
}

public db_setupDatabase()
{
	decl String:Error[255];
	g_hDb = SQL_Connect("timer", false, Error, 255);
	
	//if a connection canot be made
	if(g_hDb == INVALID_HANDLE)
	{
		LogError("Unable to connect to database (%s)", Error);
		return;
	}
}

new String:sql_QueryPlayerName[] = "SELECT name, auth FROM round WHERE name LIKE \"%%%s%%\" ORDER BY `round`.`name` ASC, `round`.`auth` ASC;";
new String:sql_selectSingleRecord[] = "SELECT auth, name, jumps, time, date, rank, finishcount, avgspeed, maxspeed, finishspeed FROM round WHERE auth LIKE '%s' AND map = '%s' AND bonus = '0';";
new String:sql_selectPlayerRowCount[] = "SELECT name FROM round WHERE time <= (SELECT time FROM round WHERE auth = '%s' AND map = '%s' AND bonus = '0') AND map = '%s' AND bonus = '0' ORDER BY time;";

new String:sql_selectPlayer_Points[] = "SELECT auth, lastname, points FROM ranks WHERE auth LIKE '%s' AND points NOT LIKE '0';";
new String:sql_selectPlayerPRowCount[] = "SELECT lastname FROM ranks WHERE points >= (SELECT points FROM ranks WHERE auth = '%s' AND points NOT LIKE '0') AND points NOT LIKE '0' ORDER BY points;";

public Action:Client_PlayerInfo(client, args)
{
	if(args < 1)
	{
		//Self_Playerinfo(client);
	}
	else if(args >= 1)
	{
		// get the clients complete args in one string
		decl String:NameBuffer[256], String:NameClean[256];
		GetCmdArgString(NameBuffer, sizeof(NameBuffer));
		new startidx = 0;
		new len = strlen(NameBuffer);
		
		if ((NameBuffer[0] == '"') && (NameBuffer[len-1] == '"'))
		{
			startidx = 1;
			NameBuffer[len-1] = '\0';
		}
		
		Format(NameClean, sizeof(NameClean), "%s", NameBuffer[startidx]);
		// ---------------------------------------------
		
		// convert args into call
		QueryPlayerName(client, NameClean);
		// ----------------------
	}
	return Plugin_Handled;
}

public QueryPlayerName(client, String:QueryPlayerName[256])
{
	decl String:Query[255];
	//escape some quote characters that could mess up the Query
	decl String:szName[MAX_NAME_LENGTH*2+1];
	SQL_QuoteString(g_hDb, QueryPlayerName, szName, MAX_NAME_LENGTH*2+1);
	
	Format(Query, 255, sql_QueryPlayerName, szName);
	
	SQL_TQuery(g_hDb, SQL_QueryPlayerNameCallback, Query, client);
}

public SQL_QueryPlayerNameCallback(Handle:owner, Handle:hndl, const String:error[], any:data){
	if(hndl == INVALID_HANDLE)
		LogError("Error loading playername (%s)", error);
		
	new client = data;
	decl String:PlayerName[256];
	decl String:SteamID[256];
	decl String:PlayerSteam[256];
	decl String:PlayerChkDup[256];
	decl String:buffer[512];
	PlayerChkDup = "zero";
	
	// Begin Menu
	new Handle:menu = CreateMenu(Menu_PlayerSearch);
	SetMenuTitle(menu, "Playersearch\n ");
	
	// get player names
	if(SQL_HasResultSet(hndl)){
		// Loop over
		new i = 0;
		while (SQL_FetchRow(hndl))
		{
			if (i <= 24)
			{
				SQL_FetchString(hndl, 0, PlayerName, 256);
				SQL_FetchString(hndl, 1, SteamID, 256);
				Format(PlayerSteam, 256, "%s - %s",PlayerName, SteamID);
				if(!StrEqual(PlayerChkDup, SteamID, false))
				{
					new Handle:pack = CreateDataPack();
					WritePackCell(pack, client);
					WritePackString(pack, SteamID);
					WritePackString(pack, PlayerName);
					Format(buffer, sizeof(buffer), "%d", pack);
					AddMenuItem(menu, buffer, PlayerSteam);
					
					Format(PlayerChkDup, 256, "%s",SteamID);
					i++;
				}
				else
				{
					Format(PlayerChkDup, 256, "%s",SteamID);
				}
			}
		}
		if((i == 0))
		{
			AddMenuItem(menu, "nope", "No Player found...", ITEMDRAW_DISABLED);
		}
		if(i > 24)
		{
			AddMenuItem(menu, "many", "More than 25 Players found.", ITEMDRAW_DISABLED);
			AddMenuItem(menu, "speci", "Please be more specific.", ITEMDRAW_DISABLED);
		}
	}
	else{
		AddMenuItem(menu, "nope", "No Player found...", ITEMDRAW_DISABLED);
	}
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public Menu_PlayerSearch(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select)
	{
		new first_item = GetMenuSelectionPosition();
		DisplayMenuAtItem(menu, param1, first_item, MENU_TIME_FOREVER); 

		decl String:data[512];
		GetMenuItem(menu, param2, data, sizeof(data));

		Menu_PlayerInfo(param1, data);
	}
}

public Menu_PlayerInfo(client, String:data[512])
{
	g_MainMenu[client][eMain_Pack] = Handle:StringToInt(data); 
	ResetPack(g_MainMenu[client][eMain_Pack]);
	ReadPackCell(g_MainMenu[client][eMain_Pack]);
	decl String:SteamID[256];
	ReadPackString(g_MainMenu[client][eMain_Pack], SteamID, 256);
	decl String:PlayerName[256];
	ReadPackString(g_MainMenu[client][eMain_Pack], PlayerName, 256);
	//CloseHandle(pack);

	g_MainMenu[client][eMain_Menu] = CreateMenu(Menu_PlayerInfo_Handler);
	SetMenuTitle(g_MainMenu[client][eMain_Menu], "%s's Overview\n(%s)\n ", PlayerName, SteamID);
	AddMenuItem(g_MainMenu[client][eMain_Menu], data, "View Record/Rank (current Map)");
	AddMenuItem(g_MainMenu[client][eMain_Menu], data, "View Points/Rank");
	AddMenuItem(g_MainMenu[client][eMain_Menu], data, "View all Records");
	AddMenuItem(g_MainMenu[client][eMain_Menu], data, "View all Records (Bonus)");
	//SetMenuExitButton(g_MainMenu[client][eMain_Pack], true);
	SetMenuExitBackButton(g_MainMenu[client][eMain_Pack], true);
	DisplayMenu(g_MainMenu[client][eMain_Pack], client, MENU_TIME_FOREVER);
}

public Menu_PlayerInfo_Handler(Handle:menu, MenuAction:action,param1, param2)
{
	if ( action == MenuAction_Select )
	{
		new first_item = GetMenuSelectionPosition();
		DisplayMenuAtItem(menu, param1, first_item, MENU_TIME_FOREVER); 
		
		decl String:data[512];
		GetMenuItem(menu, param2, data, sizeof(data));
		new Handle:pack = Handle:StringToInt(data); 
		ResetPack(pack);
		ReadPackCell(pack);
		decl String:SteamID[256];
		ReadPackString(pack, SteamID, 256);
		decl String:PlayerName[256];
		ReadPackString(pack, PlayerName, 256);
		CloseHandle(pack);

		switch (param2)
		{
			case 0:
			{
				// View Record/Rank (current Map)
				decl String:Query[255];
				Format(Query, 255, sql_selectSingleRecord, SteamID, g_MapName);
				decl String:Query2[255];
				Format(Query2, 255, sql_selectPlayerRowCount, SteamID, g_MapName, g_MapName);

				new Handle:pack2 = CreateDataPack();
				WritePackCell(pack2, param1);
				WritePackString(pack2, g_MapName);
				
				SQL_TQuery(g_hDb, SQL_GetRowCountCallback, Query2, pack2);
				SQL_TQuery(g_hDb, SQL_ViewSingleRecordCallback, Query, pack2);
			}
			case 1:
			{
				//View Points/Rank
				decl String:szQuery[255];
				Format(szQuery, 255, sql_selectPlayer_Points, SteamID);
				decl String:Query2[255];
				Format(Query2, 255, sql_selectPlayerPRowCount, SteamID);

				new Handle:pack3 = CreateDataPack();
				WritePackCell(pack3, param1);

				SQL_TQuery(g_hDb, SQL_PRowCountCallback, Query2, pack3);
				SQL_TQuery(g_hDb, SQL_PlayerPointsCallback, szQuery, pack3);
				
				PrintToChatAll("case1: %s - %s", PlayerName, SteamID);
			}
			case 2:
			{
				PrintToChatAll("case2: %s - %s", PlayerName, SteamID);
			}
			case 3:
			{
				PrintToChatAll("case3: %s - %s", PlayerName, SteamID);
			}
		}
	}
	/*else if (action == MenuAction_Cancel)
	{
		PrintToServer("Client %d's menu was cancelled.  Reason: %d", param1, param2);
	}
	else if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}*/
}

public SQL_GetRowCountCallback(Handle:owner, Handle:hndl, const String:error[], any:data){
	if(hndl == INVALID_HANDLE)
		LogError("Error getting rowcount (%s)", error);
		
	new Handle:pack = data;
	ResetPack(pack);
	
	new client = ReadPackCell(pack);
	
	if(SQL_HasResultSet(hndl) && SQL_FetchRow(hndl))
	{
		g_RowCount[client] = SQL_GetRowCount(hndl);
	}
}

public SQL_ViewSingleRecordCallback(Handle:owner, Handle:hndl, const String:error[], any:data){
	if(hndl == INVALID_HANDLE)
		LogError("Error loading single record (%s)", error);
	
	new Handle:pack = data;
	ResetPack(pack);
	
	new client = ReadPackCell(pack);
	decl String:MapName[32];
	ReadPackString(pack, MapName, 32);
	
	CloseHandle(pack);
	
	new Handle:menu = CreateMenu(Menu_Stock_Handler);
	SetMenuTitle(menu, "Record Info\n ");
	
	//if there is a player record
	if(SQL_HasResultSet(hndl) && SQL_FetchRow(hndl)){
	
		decl String:SteamId[32];
		decl String:PlayerName[MAX_NAME_LENGTH];
		decl String:Date[20];
		new rank;
		new finishcount;
		
		//get the result
		SQL_FetchString(hndl, 0, SteamId, 32);
		SQL_FetchString(hndl, 1, PlayerName, MAX_NAME_LENGTH);
		SQL_FetchString(hndl, 4, Date, 20);
		rank = SQL_FetchInt(hndl, 5);
		finishcount = SQL_FetchInt(hndl, 6);
		new Float:avgspeed = SQL_FetchFloat(hndl, 7);
		new Float:maxspeed = SQL_FetchFloat(hndl, 8);
		new Float:finishspeed = SQL_FetchFloat(hndl, 9);
		
		decl String:LineDate[32];
		Format(LineDate, 32, "Date: %s", Date);
		decl String:LinePLSteam[128];
		Format(LinePLSteam, 128, "Player: %s (%s)", PlayerName, SteamId);
		decl String:LineRank[128];
		Format(LineRank, 128, "Rank: #%i on %s [FR: #%i | FC: %i]", g_RowCount[client], MapName, rank, finishcount);
		decl String:LineTime[128];
		decl String:Time[32];		
		Timer_SecondsToTime(SQL_FetchFloat(hndl, 3), Time, 16, 2);
		Format(LineTime, 128, "Time: %s", Time);
		decl String:LineSpeed[128];
		Format(LineSpeed, 128, "Speed [Avg: %.2f | Max: %.2f | Fin: %.2f]", avgspeed, maxspeed, finishspeed);
		
		AddMenuItem(menu, "1", LineDate);
		AddMenuItem(menu, "2", LinePLSteam);
		AddMenuItem(menu, "3", LineRank);
		AddMenuItem(menu, "4", LineTime);
		AddMenuItem(menu, "5", LineSpeed);
		
		SetMenuExitButton(menu, true);
		SetMenuExitBackButton(menu, true);
		DisplayMenu(menu, client, MENU_TIME_FOREVER);
	}else{ //no valid record
		AddMenuItem(menu, "nope", "No Record Found...");
		SetMenuExitButton(menu, true);
		SetMenuExitBackButton(menu, true);
		DisplayMenu(menu, client, MENU_TIME_FOREVER);
	}
}

public SQL_PRowCountCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if(hndl == INVALID_HANDLE)
		LogError("Error viewing player point rowcount (%s)", error);
	
	new Handle:pack = data;
	ResetPack(pack);
	
	new client = ReadPackCell(pack);
	
	if(SQL_HasResultSet(hndl) && SQL_FetchRow(hndl))
	{
		g_PointRowCount[client] = SQL_GetRowCount(hndl);
	}
}

public SQL_PlayerPointsCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if(hndl == INVALID_HANDLE)
		LogError("Error loading player points (%s)", error);
	
	new Handle:pack = data;
	ResetPack(pack);
	
	new client = ReadPackCell(pack);
	
	CloseHandle(pack);
	
	new Handle:menu = CreateMenu(Menu_Stock_Handler);
	SetMenuTitle(menu, "Points Info\n ");
	
	//if there is a player record
	if(SQL_HasResultSet(hndl) && SQL_FetchRow(hndl))
	{
		decl String:SteamId[32];
		decl String:Name[128];
		decl String:Points[64];
		new points;
		
		//get the result
		SQL_FetchString(hndl, 0, SteamId, 32);
		SQL_FetchString(hndl, 1, Name, 128);
		SQL_FetchString(hndl, 2, Points, 64);
		points = SQL_FetchInt(hndl, 2);
		
		//display a panel
		decl String:LineName[128];
		decl String:LinePoints[64];
		decl String:LinePointRank[64];
		Format(LineName, 128, "Player: %s (%s)", Name, SteamId);
		Format(LinePoints, 64, "Points: %i", points);
		Format(LinePointRank, 64, "Rank: #%i", g_PointRowCount[client]);
		
		AddMenuItem(menu, "1", LineName);
		AddMenuItem(menu, "2", LinePoints);
		AddMenuItem(menu, "3", LinePointRank);
		SetMenuExitButton(menu, true);
		DisplayMenu(menu, client, MENU_TIME_FOREVER);
	}
}






public Menu_Stock_Handler(Handle:menu, MenuAction:action, param1, param2)
{
	if ( action == MenuAction_Select )
	{
		new first_item = GetMenuSelectionPosition();
		DisplayMenuAtItem(menu, param1, first_item, MENU_TIME_FOREVER); 
	}
	else if(action == MenuAction_Cancel && param2 == MenuCancel_ExitBack){

		DisplayMenu(g_MainMenu[param1][eMain_Pack], param1, MENU_TIME_FOREVER);
		//g_MainMenu[client][eMain_Pack][param1];

	}
	/*else if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}*/
}



































































































stock Timer_SecondsToTime(Float:seconds, String:buffer[], maxlength, precision)
{
	new t = RoundToFloor(seconds);
	
	new hour, mins;
	
	if (t >= 3600)
	{
		hour = RoundToFloor(t / 3600.0);
		t = t % 3600;
    }
	
	if (t >= 60)
	{
		mins = RoundToFloor(t / 60.0);
		t = t % 60;
    }

	Format(buffer, maxlength, "");
	
	if (hour)
		Format(buffer, maxlength, "%s%02d:", buffer, hour);
	
	Format(buffer, maxlength, "%s%02d:", buffer, mins);
	
	if (precision == 1)
		Format(buffer, maxlength, "%s%04.1f", buffer, float(t) + seconds - RoundToFloor(seconds));
	else if (precision == 2)
		Format(buffer, maxlength, "%s%05.2f", buffer, float(t) + seconds - RoundToFloor(seconds));
	else if (precision == 3)
		Format(buffer, maxlength, "%s%06.3f", buffer, float(t) + seconds - RoundToFloor(seconds));
	else 
		Format(buffer, maxlength, "%s%02d", buffer, t);
}